#pragma once

#include <winsock2.h>

#pragma comment(lib, "ws2_32.lib")


#include "tcpbase.h"

class CUDP :
	public CTCPBase
{
public:
	CUDP(bool bServer = false, bool bLog = false, LPCTSTR sAddr = "127.0.0.1", unsigned short nPort = 1024);
	~CUDP(void);

	bool Open();
	void Close();
	string Read(UINT nSize = 0);
	bool Write(string strWrite);
	bool InternalSelect(bool bWrite);
	void SetBlocking(bool block);

	void FlushInput(void);

private:
	WSADATA m_wsaData;
	SOCKET m_hSocket;
	SOCKADDR_IN m_servAddr;
	SOCKADDR_IN m_fromAddr;
	int m_servSize;
	bool m_bServer;
	unsigned short m_nPort;
	string m_sAddr;
};
