//  ifdef  DLL ϴ ۾   ִ ũθ  
// ǥ Դϴ.  DLL  ִ   ٿ ǵ _EXPORTS ȣ
// ϵǸ,  DLL ϴ ٸ Ʈ  ȣ   ϴ.
// ̷ ϸ ҽ Ͽ    ִ ٸ  Ʈ 
// IRONDEVICEMASTER_API Լ DLL   ,  DLL
//  DLL ش ũη ǵ ȣ   ϴ.
#ifdef IRONDEVICEMASTER_EXPORTS
#define IRONDEVICEMASTER_API __declspec(dllexport)
#else
#define IRONDEVICEMASTER_API __declspec(dllimport)
#endif

const unsigned int MAX_DEVICE = 1024;

#if defined(__cplusplus)
extern "C" {
#endif

//Common Property
IRONDEVICEMASTER_API WORD OpenPort(LPCTSTR address, WORD port, bool logging = false);
IRONDEVICEMASTER_API WORD OpenSerialPort(bool logging = false,
										 WORD port = 1,
										 UINT nBaudrate = 9600,
										 int nBytesize = 8,
										 WORD wParity = PARITY_NONE,
										 int nStopbits = 1,
										 int nTimeout = -1,
										 int nXOnXOff = 0,
										 int nRtsCts = 0,
										 int nWriteTimeout = 0,
										 int nDsrDtr = 0);
IRONDEVICEMASTER_API WORD CreateTCPServer(LPCTSTR address, WORD port, bool logging = false);
IRONDEVICEMASTER_API void ClosePort(UINT portID);
IRONDEVICEMASTER_API UINT InWaiting(UINT portID);
IRONDEVICEMASTER_API bool ReadLine(UINT portID, LPSTR strRead, UINT bufferSize, char EOL);
IRONDEVICEMASTER_API bool ReadString(UINT portID, LPSTR strRead, UINT bufferSize, UINT readSize = 1);
IRONDEVICEMASTER_API bool ReadBinary(UINT portID, BYTE* byRead, UINT bufferSize, UINT readSize);
IRONDEVICEMASTER_API bool WriteString(UINT portID, LPCTSTR strWrite);
IRONDEVICEMASTER_API bool WriteBinary(UINT portID, BYTE* byWrite, UINT writeSize);
IRONDEVICEMASTER_API void FlushInput(UINT portID);

//Serial Property
IRONDEVICEMASTER_API void SetSerialPort(UINT portID, int nPort);
IRONDEVICEMASTER_API int GetSerialPort(UINT portID);
IRONDEVICEMASTER_API void SetBaudrate(UINT portID, UINT nBaudrate);
IRONDEVICEMASTER_API UINT GetBaudrate(UINT portID);
IRONDEVICEMASTER_API void SetByteSize(UINT portID, int nBytesize);
IRONDEVICEMASTER_API int GetByteSize(UINT portID);
IRONDEVICEMASTER_API void SetParity(UINT portID, WORD wParity);
IRONDEVICEMASTER_API WORD GetParity(UINT portID);
IRONDEVICEMASTER_API void setStopbits(UINT portID, int nStopbits);
IRONDEVICEMASTER_API int GetStopbits(UINT portID);
IRONDEVICEMASTER_API void SetTimeout(UINT portID, double dTimeout);
IRONDEVICEMASTER_API double GetTimeout(UINT portID);
IRONDEVICEMASTER_API void SetWriteTimeout(UINT portID, double dTimeout);
IRONDEVICEMASTER_API double GetWriteTimeout(UINT portID);
IRONDEVICEMASTER_API void SetXonXoff(UINT portID, int nXonXoff);
IRONDEVICEMASTER_API int GetXonXoff(UINT portID);
IRONDEVICEMASTER_API void SetRtsCts(UINT portID, int nRtsCts);
IRONDEVICEMASTER_API int GetRtsCts(UINT portID);
IRONDEVICEMASTER_API void SetDsrDtr(UINT portID, int nDsrDtr);
IRONDEVICEMASTER_API int GetDsrDtr(UINT portID);
IRONDEVICEMASTER_API void FlushOutput(UINT portID);
IRONDEVICEMASTER_API void SendBreak(UINT portID);
IRONDEVICEMASTER_API void SetRTS(UINT portID, bool bLevel = true);
IRONDEVICEMASTER_API void SetDTR(UINT portID, bool bLevel = true);
IRONDEVICEMASTER_API bool GetCTS(UINT portID);
IRONDEVICEMASTER_API bool GetDSR(UINT portID);
IRONDEVICEMASTER_API bool GetRI(UINT portID);
IRONDEVICEMASTER_API bool GetCD(UINT portID);
IRONDEVICEMASTER_API void SetXON(UINT portID, bool bLevel);

#if defined(__cplusplus)
};
#endif