#pragma once

#include <windows.h>
#include <string>

using namespace std;

class CIronFile
{
public:
	CIronFile(void);
	~CIronFile(void);

	bool Create(const string& cFileName);
	bool Open(const string& cFileName, bool bReadOnly = true);
	void Close();
	UINT Read(BYTE* pBuffer, UINT uSize);
	UINT Write(BYTE* pBuffer, UINT uSize);
	UINT GetFileSize();
	FILETIME GetLastModified();
	BYTE* GetMemoryMapping();

private:
	HANDLE m_hFile;
	HANDLE m_hMapping;
	BYTE*  m_pView;
	bool   m_bReadOnly;
};
