#pragma once

#include <Serial.h>

class CDevice:
	public CSerial,
	public CIronSynchObject
{
public:
	CDevice(void);
	CDevice(bool bLog, unsigned uPort);
	~CDevice(void);
	
	LONG GetStatus(int& nVal);
	LONG SetAddress(int nVal);
	LONG GetOxygen(double& dVal);

private:
	int CheckSum(string& strVal);

private:
	int m_nAddress;
};
