//  ifdef  DLL ϴ ۾   ִ ũθ  
// ǥ Դϴ.  DLL  ִ   ٿ ǵ _EXPORTS ȣ
// ϵǸ,  DLL ϴ ٸ Ʈ  ȣ   ϴ.
// ̷ ϸ ҽ Ͽ    ִ ٸ  Ʈ 
// ROBOSTAR_API Լ DLL   ,  DLL
//  DLL ش ũη ǵ ȣ   ϴ.
#ifdef ROBOSTAR_EXPORTS
#define ROBOSTAR_API __declspec(dllexport)
#else
#define ROBOSTAR_API __declspec(dllimport)
#endif

#define DI_LowArmWaferExist			0
#define DI_UpperArmWaferExist		1
#define DI_InitialStaus				2
#define DI_FGReadyStaus				3
#define DI_PutIntoStatus			4
#define DI_GetFromStatus			5
#define DI_MapScanStatus			6
#define DI_Running					7
#define DI_Error					8
#define DI_Servo					9
#define DI_Mode						10
#define DI_Position					11
#define DI_ArmState					12

#define SI_MapData					0

#define DO_Initialize				0
#define DO_ServoOffOn				1
#define DO_Station					2
#define DO_Slot						3
#define DO_Arm						4
#define DO_FGReady					5
#define DO_PutInto					6
#define DO_GetFrom					7
#define DO_MapScan					8
#define DO_Stop						9
#define DO_Resume					10
#define DO_Reset					11
#define DO_Pause					12
#define DO_VacCtrl					13
#define DO_WaferCheck				14


void SetTimeout(int nTimeout);
void ResetTimeout(int nTimeout);

#if defined(__cplusplus)
extern "C" {
#endif

ROBOSTAR_API LONG InitDriver(unsigned uPort, int nTimeout, bool bLog);
ROBOSTAR_API LONG UninitDriver(void);
ROBOSTAR_API LONG ReadAnalog(double &dInput, unsigned uAddr, unsigned uIndex, int nTimeout);
ROBOSTAR_API LONG ReadDigital(int &nInput, unsigned uAddr, unsigned uIndex, int nTimeout);
ROBOSTAR_API LONG ReadString(LPTSTR strInput, unsigned uAddr, unsigned uIndex, unsigned uSize, int nTimeout);
ROBOSTAR_API LONG ReadVariable(LPCTSTR strName, unsigned uAddr, unsigned uIndex, unsigned uSize, void* pData, int nTimeout);
ROBOSTAR_API LONG WriteAnalog(double dOutput, unsigned uAddr, unsigned uIndex, int nTimeout);
ROBOSTAR_API LONG WriteDigital(int nOutput, unsigned uAddr, unsigned uIndex, int nTimeout);
ROBOSTAR_API LONG WriteString(LPCTSTR strOutput, unsigned uAddr, unsigned uIndex, int nTimeout);
ROBOSTAR_API LONG WriteVariable(LPCTSTR strName, unsigned uAddr, unsigned uIndex, unsigned uSize, void* pData, int nTimeout);

#if defined(__cplusplus)
};
#endif