#pragma once

#include <winsock2.h>

#pragma comment(lib, "ws2_32.lib")


#include "tcpbase.h"

class CTCP :
	public CTCPBase,
	public CIronThread
{
public:
	CTCP(bool bLog = false, bool bServer = false, LPCTSTR sAddr = "127.0.0.1", unsigned short nPort = 1024);
	~CTCP(void);

	bool Open();
	void Close();
	unsigned int InWaiting(void);
	string Read(UINT nSize = 0);
	bool Read(BYTE* byRead, UINT nSize);
	bool Write(string strWrite);
	bool Write(BYTE* byWrite, UINT nSize);
	bool InternalSelect(bool bWrite);
	void SetBlocking(bool block);
	void FlushInput(void);

	bool IsOpen() { return m_bOpen; }

private:
	void OnExecute();

private:
	HANDLE m_hStopEvent;
	WSADATA m_wsaData;
	SOCKET m_hSocket;
	SOCKADDR_IN m_sockAddr;
	bool m_bServer;
	unsigned short m_nPort;
	string m_sAddr;
};
