// DeviceManager.h : CDeviceManager Դϴ.

#pragma once
#include "resource.h"       //  ȣԴϴ.

#include "IronSAN.h"
#include "deviceinfo.h"

#include <string>

using namespace std;

typedef struct _tagDeviceInfo DEVICE_INFO;

// CDeviceManager

class ATL_NO_VTABLE CDeviceManager :
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDeviceManager, &CLSID_DeviceManager>,
	public ISupportErrorInfo,
	public IDispatchImpl<IDeviceManager, &IID_IDeviceManager, &LIBID_IronSANLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public CIronSynchObject
{
public:
	CDeviceManager()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DEVICEMANAGER)
DECLARE_CLASSFACTORY_SINGLETON(CDeviceManager)

BEGIN_COM_MAP(CDeviceManager)
	COM_INTERFACE_ENTRY(IDeviceManager)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct();
	void FinalRelease();

private:
	CDeviceInfo m_cDeviceInfo;
	CDevice* m_pVirtual;

	map<string, DEVICE_INFO> m_devicses;
	map<string, CDevice*> m_mDevice;
public:

	STDMETHOD(Read)(BSTR tag, BSTR* value);
	STDMETHOD(Write)(BSTR tag, BSTR value, BSTR* result);
};

OBJECT_ENTRY_AUTO(__uuidof(DeviceManager), CDeviceManager)
