// VirtualActiveElement.h : CVirtualActiveElement Դϴ.

#pragma once

// ڵ  ġ 2009 7 20 ,  3:10

#include <string>
using namespace std;

class CVirtualActiveElementAccessor
{
public:
	TCHAR m_DataUnits[51];
	TCHAR m_Description[101];
	TCHAR m_Device[51];
	TCHAR m_Driver[51];
	LONG m_ID;
	LONG m_IOAddress;
	LONG m_IOIndex;
	double m_Maximum;
	double m_Minimum;
	TCHAR m_Name[51];
	// ISequentialStream* m_Note;
	TCHAR m_Note[8000];
	TCHAR m_Setting[51];
	LONG m_Timeout;
	TCHAR m_Type[51];

	//         ش 
	// ʵ忡     ֽϴ.  
	// Ͽ ͺ̽ȯϴ NULL 
	// ϰų Ϸ  ȯ 
	//     ֽϴ. ̷ ʵ 뿡
	//  ڼ  Visual C++ 
	//  "  " "ʵ   " Ͻʽÿ.
	// : ͸ /ϱ  ̵ ʵ带 ʱȭؾ մϴ.

	DBSTATUS m_dwDataUnitsStatus;
	DBSTATUS m_dwDescriptionStatus;
	DBSTATUS m_dwDeviceStatus;
	DBSTATUS m_dwDriverStatus;
	DBSTATUS m_dwIDStatus;
	DBSTATUS m_dwIOAddressStatus;
	DBSTATUS m_dwIOIndexStatus;
	DBSTATUS m_dwMaximumStatus;
	DBSTATUS m_dwMinimumStatus;
	DBSTATUS m_dwNameStatus;
	DBSTATUS m_dwNoteStatus;
	DBSTATUS m_dwSettingStatus;
	DBSTATUS m_dwTimeoutStatus;
	DBSTATUS m_dwTypeStatus;

	//        ش ʵ忡 
	//    ֽϴ.
	// :     ͸ /ϱ  
//       ̷ 	 ʵ带 ʱȭؾ մϴ.

	DBLENGTH m_dwDataUnitsLength;
	DBLENGTH m_dwDescriptionLength;
	DBLENGTH m_dwDeviceLength;
	DBLENGTH m_dwDriverLength;
	DBLENGTH m_dwIDLength;
	DBLENGTH m_dwIOAddressLength;
	DBLENGTH m_dwIOIndexLength;
	DBLENGTH m_dwMaximumLength;
	DBLENGTH m_dwMinimumLength;
	DBLENGTH m_dwNameLength;
	DBLENGTH m_dwNoteLength;
	DBLENGTH m_dwSettingLength;
	DBLENGTH m_dwTimeoutLength;
	DBLENGTH m_dwTypeLength;


	void GetRowsetProperties(CDBPropSet* pPropSet)
	{
		pPropSet->AddProperty(DBPROP_CANFETCHBACKWARDS, true, DBPROPOPTIONS_OPTIONAL);
		pPropSet->AddProperty(DBPROP_CANSCROLLBACKWARDS, true, DBPROPOPTIONS_OPTIONAL);
		// pPropSet->AddProperty(DBPROP_ISequentialStream, true);
		pPropSet->AddProperty(DBPROP_IRowsetChange, true, DBPROPOPTIONS_OPTIONAL);
		pPropSet->AddProperty(DBPROP_UPDATABILITY, DBPROPVAL_UP_CHANGE);
	}

	HRESULT OpenDataSource()
	{
		CDataSource _db;
		HRESULT hr;
//#error Security Issue: The connection string may contain a password
// Ʒ  ڿ Ϲ ؽƮ ȣ /Ǵ 
// ٸ ߿  ԵǾ   ֽϴ.
//    ִ  ڿ  Ŀ #error() Ͻʽÿ.
// ٸ  ȣ ϰų ٸ   Ͻʽÿ.
		
		char strDatabase[FILENAME_MAX];

		if( !CIronLib::ReadRegistryString(HKEY_LOCAL_MACHINE, "SOFTWARE\\IronTools\\Application\\", NULL, "C:\\IronTools\\", strDatabase, FILENAME_MAX) )
		{
			CIronLib::WriteDebugLog("ReadRegistryString() return is false.(%s:%d)", __FILE__, __LINE__);
		}

		string strPath = strDatabase;

		if( strPath.find_last_of('\\') != strPath.size() - 1 )
		{
			strPath += "\\";
		}

		CIronLib::WriteDebugLog("Virtual DB = %sDatabase\\Virtual.mdb", strPath.c_str());

		string dbConnectString = "Provider=Microsoft.Jet.OLEDB.4.0;User ID=Admin;";
		dbConnectString += (string)"Data Source=" + strPath + "Database\\Virtual.mdb;";
		dbConnectString += "Mode=Share Deny None;Extended Properties=\"\";Jet OLEDB:System database=\"\";Jet OLEDB:Registry Path=\"\";Jet OLEDB:Database Password=\"\";Jet OLEDB:Engine Type=5;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Global Bulk Transactions=1;Jet OLEDB:New Database Password=\"\";Jet OLEDB:Create System Database=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:SFP=False";

		USES_CONVERSION;
		hr = _db.OpenFromInitializationString(A2OLE(dbConnectString.c_str()));
		if (FAILED(hr))
		{
#ifdef _DEBUG
			AtlTraceErrorRecords(hr);
#endif
			return hr;
		}
		return m_session.Open(_db);
	}

	void CloseDataSource()
	{
		m_session.Close();
	}

	operator const CSession&()
	{
		return m_session;
	}

	CSession m_session;

	DEFINE_COMMAND_EX(CVirtualActiveElementAccessor, L" \
	SELECT \
		DataUnits, \
		Description, \
		Device, \
		Driver, \
		ID, \
		IOAddress, \
		IOIndex, \
		Maximum, \
		Minimum, \
		Name, \
		Note, \
		Setting, \
		Timeout, \
		Type \
		FROM VirtualActiveElement")

//  ̺/ɿ ISequentialStream ̽ 
// ׼  ִ   ֽϴ. ׷  ڰ
//   ϴ  ƴϸ   ϴ ڵ
//  ϳ  տ  ϳ ISequentialStream ϵ  ޽ϴ.
//   Ʈ Ϸ Ʒ  ڵ带 ϰ
// DBPROP_ISequentialStream   Ӽ true Ͻʽÿ.
// ׷ Read() ޼带 Ͽ ͸ аų
// Write() ޼带 Ͽ ͸   ֽϴ.
// ̷ Ϸ STGM_READ Ʈ Ӽ STGM_WRITE Ǵ STGM_READWRITE
// ؾ մϴ.
// ISequentialStream ε  ڼ   Ͻʽÿ.

	// Ϻ ڿ õ   ذϱ  Ʒ ڵ忡 
	// ڰ ϴ Ͱ ٸ   ε  ֽϴ.

	BEGIN_COLUMN_MAP(CVirtualActiveElementAccessor)
		COLUMN_ENTRY_LENGTH_STATUS(1, m_DataUnits, m_dwDataUnitsLength, m_dwDataUnitsStatus)
		COLUMN_ENTRY_LENGTH_STATUS(2, m_Description, m_dwDescriptionLength, m_dwDescriptionStatus)
		COLUMN_ENTRY_LENGTH_STATUS(3, m_Device, m_dwDeviceLength, m_dwDeviceStatus)
		COLUMN_ENTRY_LENGTH_STATUS(4, m_Driver, m_dwDriverLength, m_dwDriverStatus)
		COLUMN_ENTRY_LENGTH_STATUS(5, m_ID, m_dwIDLength, m_dwIDStatus)
		COLUMN_ENTRY_LENGTH_STATUS(6, m_IOAddress, m_dwIOAddressLength, m_dwIOAddressStatus)
		COLUMN_ENTRY_LENGTH_STATUS(7, m_IOIndex, m_dwIOIndexLength, m_dwIOIndexStatus)
		COLUMN_ENTRY_LENGTH_STATUS(8, m_Maximum, m_dwMaximumLength, m_dwMaximumStatus)
		COLUMN_ENTRY_LENGTH_STATUS(9, m_Minimum, m_dwMinimumLength, m_dwMinimumStatus)
		COLUMN_ENTRY_LENGTH_STATUS(10, m_Name, m_dwNameLength, m_dwNameStatus)
		// BLOB_ENTRY_LENGTH_STATUS(11, IID_ISequentialStream, STGM_READ, m_Note, m_dwNoteLength, m_dwNoteStatus)
		COLUMN_ENTRY_LENGTH_STATUS(11, m_Note, m_dwNoteLength, m_dwNoteStatus)
		COLUMN_ENTRY_LENGTH_STATUS(12, m_Setting, m_dwSettingLength, m_dwSettingStatus)
		COLUMN_ENTRY_LENGTH_STATUS(13, m_Timeout, m_dwTimeoutLength, m_dwTimeoutStatus)
		COLUMN_ENTRY_LENGTH_STATUS(14, m_Type, m_dwTypeLength, m_dwTypeStatus)
	END_COLUMN_MAP()
};

class CVirtualActiveElement : public CCommand<CAccessor<CVirtualActiveElementAccessor> >
{
public:
	HRESULT OpenAll()
	{
		HRESULT hr;
		hr = OpenDataSource();
		if (FAILED(hr))
			return hr;
		__if_exists(GetRowsetProperties)
		{
			CDBPropSet propset(DBPROPSET_ROWSET);
			__if_exists(HasBookmark)
			{
				if( HasBookmark() )
					propset.AddProperty(DBPROP_IRowsetLocate, true);
			}
			GetRowsetProperties(&propset);
			return OpenRowset(&propset);
		}
		__if_not_exists(GetRowsetProperties)
		{
			__if_exists(HasBookmark)
			{
				if( HasBookmark() )
				{
					CDBPropSet propset(DBPROPSET_ROWSET);
					propset.AddProperty(DBPROP_IRowsetLocate, true);
					return OpenRowset(&propset);
				}
			}
		}
		return OpenRowset();
	}

	HRESULT OpenRowset(DBPROPSET *pPropSet = NULL)
	{
		HRESULT hr = Open(m_session, NULL, pPropSet);
#ifdef _DEBUG
		if(FAILED(hr))
			AtlTraceErrorRecords(hr);
#endif
		return hr;
	}

	void CloseAll()
	{
		Close();
		ReleaseCommand();
		CloseDataSource();
	}
};


