#pragma once

#include <io.h>
#include <string>

using namespace std;

#include "IronLib.h"
#include "IronCriticalSection.h"

class CIronLog : public CIronSynchObject
{
public:
	CIronLog(void);
	CIronLog(string sDrivername, string sFoldername);
	~CIronLog(void);

	void Open(string sDrivername, string sFoldername = ".\\Log\\");
	void WriteLog(const char *format, ...);
	void UpdateFileName(void);
	void OpenFile(void);
	string GetFoldername(void){ return m_sFoldername; }
	string GetFilename(void){ return m_sFilename; }
	void SetFoldername(string sFoldername);
	void SetDrivername(string sComport);

private:
	string m_sFoldername;
	string m_sFilename;
	string m_sDrivername;
	FILE *m_fp;
};
