//  ifdef  DLL ϴ ۾   ִ ũθ  
// ǥ Դϴ.  DLL  ִ   ٿ ǵ _EXPORTS ȣ
// ϵǸ,  DLL ϴ ٸ Ʈ  ȣ   ϴ.
// ̷ ϸ ҽ Ͽ    ִ ٸ  Ʈ 
// WACCO_API Լ DLL   ,  DLL
//  DLL ش ũη ǵ ȣ   ϴ.
#ifdef WACCO_EXPORTS
#define WACCO_API __declspec(dllexport)
#else
#define WACCO_API __declspec(dllimport)
#endif

#define AI_AngleOffset				0
#define AI_Angle					1

#define AO_AngleOffset				0
#define AO_Angle					1

#define DI_WaferExistence			0
#define DI_ChuckPosition			1
#define DI_ErrorStatus				2

#define DI_SystemSetting			3	//Address
#define DI_StayChuckVacuum			0	//Index
#define DI_InitialChuckPosition		1	//Index
#define DI_CenteringOption			3	//Index

#define DI_SystemStatus				4	//Address
#define DI_Busy						0	//Index
#define DI_Error					3	//Index
#define DI_Home						7	//Index

#define DI_Vacuum					5
#define DI_WaferSize				6
#define DI_Complete					7

#define DO_ChuckUpDown				0
#define DO_ErrorClear				1
#define DO_RunCalibration			2
#define DO_Reset					3
#define DO_Initialize				4
#define DO_RotateWafer				5

#define DO_SystemSetting			6	//Address
#define DO_StayChuckVacuum			0	//Index
#define DO_InitialChuckPosition		1	//Index
#define DO_CenteringOption			3	//Index

#define DO_StartAligment			7
#define DO_Vacuum					8
#define DO_WaferSize				9
#define DO_CheckWaferExistence		10

void SetTimeout(int nTimeout);
void ResetTimeout(int nTimeout);

#if defined(__cplusplus)
extern "C" {
#endif

WACCO_API LONG InitDriver(unsigned uPort, int nTimeout, bool bLog);
WACCO_API LONG UninitDriver(void);
WACCO_API LONG ReadAnalog(double &dInput, unsigned uAddr, unsigned uIndex, int nTimeout);
WACCO_API LONG ReadDigital(int &nInput, unsigned uAddr, unsigned uIndex, int nTimeout);
WACCO_API LONG ReadString(LPTSTR strInput, unsigned uAddr, unsigned uIndex, unsigned uSize, int nTimeout);
WACCO_API LONG ReadVariable(LPCTSTR strName, unsigned uAddr, unsigned uIndex, unsigned uSize, void* pData, int nTimeout);
WACCO_API LONG WriteAnalog(double dOutput, unsigned uAddr, unsigned uIndex, int nTimeout);
WACCO_API LONG WriteDigital(int nOutput, unsigned uAddr, unsigned uIndex, int nTimeout);
WACCO_API LONG WriteString(LPCTSTR strOutput, unsigned uAddr, unsigned uIndex, int nTimeout);
WACCO_API LONG WriteVariable(LPCTSTR strName, unsigned uAddr, unsigned uIndex, unsigned uSize, void* pData, int nTimeout);

#if defined(__cplusplus)
};
#endif